﻿using System;
using System.Linq;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Media;
using Telerik.Windows.Controls.Map;

namespace SilverlightApplication14
{
    public partial class MainPage : UserControl
    {
        public MainPage()
        {
            InitializeComponent();
        }

        private void MapShapeReader_ReadCompleted(object sender, Telerik.Windows.Controls.Map.ReadShapesCompletedEventArgs eventArgs)
        {
            InformationLayer layer = (sender as MapShapeReader).Layer;

            this.SetBestView(layer);

            foreach (MapShape mapShape in layer.Items)
            {
                mapShape.CaptionTemplate = this.LayoutRoot.Resources["CaptionTemplate"] as DataTemplate;
                mapShape.CaptionLocation = mapShape.GeographicalBounds.Center;

                // Simulates dynamic & custom country colorization based on some business rule.
                if (((double)mapShape.ExtendedData.GetValue("SUM_POP_AD")) < 8000000)
                {
                    mapShape.Fill = new SolidColorBrush(Colors.Orange);
                }
                else
                {
                    mapShape.Fill = new SolidColorBrush(Colors.DarkGray);
                }

                mapShape.Stroke = new SolidColorBrush(Colors.White);
                mapShape.StrokeThickness = 2;
            }
        }

        private void MapShapeReader_PreviewReadCompleted(object sender, PreviewReadShapesCompletedEventArgs eventArgs)
        {
            // eventArgs.Items holds all read map shapes

        }

        private void SetBestView(InformationLayer layer)
        {
            RadMap1.SetView(layer.GetBestView(layer.Items.Cast<object>()));
        }

        private void Button_Click(object sender, RoutedEventArgs e)
        {
            var reader = this.infoLayer.Reader as MapShapeReader;
            reader.DataSource = new Uri("DataSources/Europe.dbf", UriKind.RelativeOrAbsolute);
            reader.Source = new Uri("DataSources/Europe.shp", UriKind.RelativeOrAbsolute);
        }
    }
}
